import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.nio.CharBuffer;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Calendar;
import java.text.SimpleDateFormat;

public class MATIP_Server{

	ServerSocket sSocket;
	String choice;
	String outmessage;
	byte[] outmessageBytes;
	int outmessageLength;
	byte byte03;
	byte byte04;
	int shiftedbyte03;
	int currentSRLN;
	int port ;
		
	private static MATIP_Server receiver;
	
	public static void main(String[] args) throws Exception {
		int port = 1111;
		if(args.length >0){
			port   = Integer.parseInt(args[0]);
		}		
		receiver = new MATIP_Server();
		Calendar cal = Calendar.getInstance();
		SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss");
		System.out.println("===============================================================================");
		System.out.println("====>");
		System.out.println("====> INTRODUCTORY INSTRUCTIONS:");
		System.out.println("====>");
		System.out.println("====> This MATIP Server application is started at " + sdf.format(cal.getTime()) );
		System.out.println("====> Now this app has started, please deploy the WMB MATIP_Client Flow.");
		System.out.println("====> As soon as the flow is deployed it will send an Open Session message.");
		System.out.println("====> To receive the Open Session message, once a TCPIP connection is active,");
		System.out.println("====> it is recommended that you type READ below.");
		System.out.println("====> Then, once the Open Session arrives, send an OC1 in response.");
		System.out.println("====> This will establish the MATIP session.");				
		System.out.println("====>");
		System.out.println("====> Now waiting for a connection - deploy the MATIP_Client flow! ... "); 		
		System.out.println("====>");
		receiver.runMATIP_Server(port);
	}
	
	public void runMATIP_Server(int port) {
		try {
			this.port = port;
			sSocket = new ServerSocket(port);
			while(true){
			  Socket socket = sSocket.accept();
			  ReceiveData receiveData = new ReceiveData(socket);
			  Thread thread = new Thread(receiveData);
			  thread.start();
			  currentSRLN  = 1; // Initialise SRLN 
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public class ReceiveData implements Runnable{
		BufferedInputStream bis;
		OutputStream os;
		InputStream is;
		InputStreamReader isr;
		BufferedReader br;
		Socket socket;
		CharBuffer chbuf;

		public ReceiveData(Socket socket) {
		try {
			this.socket = socket;
			BufferedInputStream bis = new BufferedInputStream(socket.getInputStream());
			isr = new InputStreamReader(bis);
			br = new BufferedReader(isr);
			os = socket.getOutputStream();
		} catch (Exception e) {
			e.printStackTrace();
		}		
	}

	public void run() {
		try {
			while (true) {
				StringBuffer benbuf = new StringBuffer();
				int c;				
				int TCPIPLength = 4;
				String choice;								
				System.out.println("====> A TCPIP connection is active ... "); 		
				System.out.println("====> To listen for input type READ. To send output type anything else:");
				System.out.print("====> ");
				BufferedReader stinbr = new BufferedReader(new InputStreamReader(System.in));
			    choice = null;
			    try {
			         choice = stinbr.readLine();
			    } catch (IOException ioe) {
			         System.out.println("IO error trying to read the response.");
			         System.exit(1);
			    }			    
			    if(choice.equals("READ")) {								
			    	// First test if the buffer is not empty ... 
			    	// If buffer is empty offer the chance to send data ...
			    	if ((c = br.read()) != -1) { 
			    		char currentchar = (char) c;
			    		benbuf.append(currentchar);
			    		for (int i=2; i < TCPIPLength+1; i++) {
			    			c = br.read();
			    			byte byte04;					
			    			if(i==3) {
			    				byte03 = (byte)c;
			    			} else if(i==4) {
			    				byte04 = (byte)c;
			    				shiftedbyte03 = byte03 << 8;
			    				TCPIPLength = shiftedbyte03  | byte04;
		        			}
							char currentchar1 = (char) c;
							benbuf.append(currentchar1);	            					
			    		}		        					
			    		int charlength = benbuf.length();
			    		String line = benbuf.toString();
			    		byte[] buf;
			    		buf = line.getBytes();				
			    		String messageBinary;
			    		String hexmessageBinary;				
			    		messageBinary = conversionofbuf(buf,charlength);
			    		hexmessageBinary = hexconversionofbuf(buf,charlength);
			    		System.out.println("====> ");
			    		System.out.println("====> Data has been received ...");
			    		System.out.println("====> ");
			    		System.out.println("====> Represented as hex it was as follows:");
			    		System.out.println("====> " + hexmessageBinary);
			    		System.out.println("====> ");
			    		System.out.println("====> Represented as binary it was as follows:");
			    		System.out.println("====> " + messageBinary);
			    		System.out.println("====> ");			    		
			    	}				
			    } else {
			    	// Arrival through here means that something other than READ was specified ...
			    	System.out.println("====> ");
			    	System.out.println("====> Now please select the response to send:");
			    	System.out.println("====> ");			    	
			    	System.out.println("====> Type OC1 (for Open Confirm Accept)");
			    	System.out.println("====> ");			    	
			    	System.out.println("====> Type anything else and it will be sent as a data message.");			   
			    	System.out.println("====> IMA messages will be sent exactly as you type them here.");
			    	System.out.println("====> Other data messages will be given an SRLN number for you.");			    	
			    	System.out.print("====> ");
			    	BufferedReader sibr = new BufferedReader(new InputStreamReader(System.in));
			    	outmessage = null;
			    	try {
			    		outmessage = sibr.readLine();
			    	} catch (IOException ioe) {
			    		System.out.println("IO error trying to read the response.");
			    		System.exit(1);
			    	}
			    	// By default just treat the string as the message we should send
			    	outmessageBytes = outmessage.getBytes(); 
			    	if(outmessage.equals("OC1")) {
					//  OPEN CONFIRM MESSAGE AS FOLLOWS:
					//  00000001 = x01		Version
					//  10000000 = x80		Control Packet (as opposed to data)
					//  00000000 = x00		Length Byte 1
					//  00000101 = x05		Length Byte 2
					//  00000000 = x00		Cause - Accept the connection
					outmessage = "0180000500";
					outmessageBytes = convertHex(outmessage);
					outmessageLength = 5;
					os.write(outmessageBytes);				
		    		System.out.println("====> ");
		    		System.out.println("====> Data has been sent ...");
		    		System.out.println("====> ");
		    		System.out.println("====> Represented as hex it was as follows:");
					System.out.println("====> " + hexconversionofbuf(outmessageBytes,outmessageLength));
		    		System.out.println("====> ");
		    		System.out.println("====> Represented as binary it was as follows:");
					System.out.println("====> " + conversionofbuf(outmessageBytes,outmessageLength));
		    		System.out.println("====> ");			    											
				} else {
					if(outmessage.substring(0,3).equals("IMA")) {
						// Do nothing - IMAs don't need a BATAP Trailer. 
						// This code relies on the user to just type the IMA they want.
					} else {
						String SRLN = Integer.toString(currentSRLN);
						for (int j = 0; j < (4 - SRLN.length()); j++) {
							// This loop pads the SRLN to 3 digits
							SRLN = "0" + SRLN; 						
						}
						// Add on the BATAP Trailer ... 
						// A space character symbolises a "normal" data message and not a PDM
						outmessage = outmessage + " " + SRLN;
						// Increment the SRLN ready for the next sending of a message
						currentSRLN++; 
					}
					outmessageLength = outmessage.length() + 4;
					String hexmessagelength = Integer.toHexString(outmessageLength);					
					int maxloop = 4 - (hexmessagelength.length());
					for (int i = 0; i < maxloop; i++) {
						hexmessagelength = "0" + hexmessagelength;
					}															
					outmessageBytes = convertHex("0100" + hexmessagelength);
					byte[] finalarray = new byte[outmessageBytes.length + outmessage.getBytes().length];
					System.arraycopy(convertHex("0100" + hexmessagelength), 0, finalarray, 0, convertHex("0100" + hexmessagelength).length);
					System.arraycopy(outmessage.getBytes(), 0, finalarray, convertHex("0180" + hexmessagelength).length, outmessage.getBytes().length);
					os.write(finalarray);
		    		System.out.println("====> ");
		    		System.out.println("====> Data has been sent ...");
		    		System.out.println("====> ");
		    		System.out.println("====> Represented as hex it was as follows:");
		    		System.out.println("====> " + hexconversionofbuf(finalarray,finalarray.length));		    		
		    		System.out.println("====> ");
		    		System.out.println("====> Represented as binary it was as follows:");
					System.out.println("====> " + conversionofbuf(finalarray,finalarray.length));
		    		System.out.println("====> ");																			
				}
			}
			System.out.println("===============================================================================");
			System.out.println("====> ");
			} // This closes the while loop			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}		
}

	  public static byte[] convertHex(char[] hex) {

		  int length = hex.length / 2;
		  byte[] raw = new byte[length];
		    for (int i = 0; i < length; i++) {
		      int high = Character.digit(hex[i * 2], 16);
		      int low = Character.digit(hex[i * 2 + 1], 16);
		      int value = (high << 4) | low;
		      if (value > 127)
		        value -= 256;
		      raw[i] = (byte) value;
		    }
		    return raw;
		  }	
	
	public static byte[] convertHex(String stringhex) {
		    return convertHex(stringhex.toCharArray());
	}
	  	

	public static String conversionofbuf(byte[] inbuf, int chlen) {		
	
		StringBuffer strbuf = new StringBuffer();
		for (int i=0; i<chlen; i++ ) {
			byte currentbyte = inbuf[i];			
			for (int j=0; j<8; j++) {
				strbuf.append((int)(currentbyte>>(8-(j+1)) & 0x0001));
		   }
			strbuf.append(" ");
			int k = (i+1) % 8;
			if(k==0) {
				strbuf.append("\n====> ");
			}			
		}
		return strbuf.toString();
	}
	
	public static String hexconversionofbuf(byte[] inbuf, int chlen) {		
		StringBuffer hexstrbuf = new StringBuffer();
		for (int i=0; i<chlen; i++ ) {
			byte currentbyte = inbuf[i];
			int positiveValue = currentbyte & 0x000000FF;
			String hexpair =Integer.toHexString(positiveValue);
			if (hexpair.length() == 2) 
				{hexstrbuf.append(hexpair);}
			else
				{hexstrbuf.append("0"+hexpair);}
		}
		return hexstrbuf.toString();
	}
	
}